unit Main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ExtCtrls, Menus, StrUtils, IniFiles;

  {Diese beiden Unit's einbinden.}
  {StrUtils = Zugriff auf die Funktionen [XOrEncode],[XOrDecode]}
  {IniFiles = Unit um mit IniFiles zu Arbeiten.}


type

  { TMF }

  TMF = class(TForm)
    BTN_Krypt: TButton;
    BTN_Entkrypt: TButton;
    BTN_Clear: TButton;
    PWD_KryptDreh: TLabeledEdit;
    PWD_Entkrypt: TLabeledEdit;
    PWD_Key: TLabeledEdit;
    MN_NIL1: TMenuItem;
    MN_Speichern: TMenuItem;
    MN_Beenden: TMenuItem;
    MN_Datei: TMenuItem;
    MM: TMainMenu;
    PWD_Quelle: TLabeledEdit;
    PWD_Krypt: TLabeledEdit;
    procedure BTN_ClearClick(Sender: TObject);
    procedure BTN_EntkryptClick(Sender: TObject);
    procedure BTN_KryptClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MN_BeendenClick(Sender: TObject);
    procedure MN_SpeichernClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  MF : TMF;

  VzHome : String; {Globale Variable, dient zur Aufnahme des Verzeichnispfades,}
                   {in welchem das Programm gestartet wurde.                   }


implementation

{ TMF }


{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}
{ Funktion-Name...: DREH  (Einen String drehen.)                               }
{ Erstellt durch..: Cargo_03                                                   }
{ Geändert durch..: Cargo_03                                                   }
{ Stand...........: 02.06.1996                                                 }
{ Letzte Änderung.: 02.06.1996                                                 }
{ Übergabewert(e).: String                                                     }
{ Rückgabewert....: String                                                     }
{ Beschreibung....: Funktion um einen String zu drehen.                        }
{                   Beispiel: Heute ist    ->  tsi etueH                       }
{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}
Function Dreh(Org : ShortString) : String;
Var Za : Integer;
    Er : String;
    Ze : String;
Begin
  ZE := '';
  Er := '';
  For Za := High(Org) downto 1 DO
  Begin
    Ze := Copy(Org,Za,1);
    Er := Er + Ze;
  End;
  Dreh := Er;
End; {Ende der Funktion}
{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}
{((((((((((((((((((((((     Ende der Function      ))))))))))))))))))))))))))))}
{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}


{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}
{ Procedure-Name..: FormCreate                                                 }
{ Erstellt durch..: Cargo_03                                                   }
{ Geändert durch..: Cargo_03                                                   }
{ Stand...........: 12.05.2010                                                 }
{ Letzte Änderung.: 12.05.2010                                                 }
{ Beschreibung....: Wenn die Form erstellt wird, soll das Verzeichnis ermittelt}
{                   werden, in der das Programm gestartet wurde. Denn dort     }
{                   wollen wir die INI.Datei ablegen und auch beim erneuten    }
{                   Start wieder auslesen.                                     }
{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}
Procedure TMF.FormCreate(Sender: TObject);
Var  KRIni : TIniFile;
Begin
  {++++++ Globale Variable (VzHome) mit Programm-Pfad belegen. ++++++++++++++++}
  VzHome := ExtractFileDir(Application.ExeName);
  {++++++ Und je nach Betriebssystem einen Separator anhängen. ++++++++++++++++}
  VzHome := VzHome+'/';   {Für Linux = /  Für Windows = \}
  {++++++ Ini-Datei initialisieren.  ++++++++++++++++++++++++++++++++++++++++++}
  KRIni                            := TIniFile.Create(VzHome+'Krypt.ini',True);
  {++++++ Ini-Datei auslesen. +++++++++++++++++++++++++++++++++++++++++++++++++}
  PWD_Key.Text                     := KRIni.ReadString('Passwort','Schluessel'     ,'');
  PWD_Quelle.Text                  := KRIni.ReadString('Passwort','Original'       ,'');
  PWD_Krypt.Text                   := KRIni.ReadString('Passwort','Verschluesselt' ,'');
  PWD_KryptDreh.Text               := KRIni.ReadString('Passwort','VerschlDreh'    ,'');
  PWD_Entkrypt.Text                := KRIni.ReadString('Passwort','Entschluesselt' ,'');
  {++++++ Ini-Datei wieder freigeben. +++++++++++++++++++++++++++++++++++++++++}
  KRIni.Free;
EnD;
{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}
{((((((((((((((((((((((     Ende der Procedure     ))))))))))))))))))))))))))))}
{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}


{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}
{ Procedure-Name..: MN_BeendenClick                                            }
{ Erstellt durch..: Cargo_03                                                   }
{ Geändert durch..: Cargo_03                                                   }
{ Stand...........: 12.05.2010                                                 }
{ Letzte Änderung.: 12.05.2010                                                 }
{ Beschreibung....: Wenn der Menü-Punkt "Beenden" angeklickt wurde, soll das   }
{                   Programm beendet werden.                                   }
{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}
Procedure TMF.MN_BeendenClick(Sender: TObject);
Begin
  Close;
EnD;
{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}
{((((((((((((((((((((((     Ende der Procedure     ))))))))))))))))))))))))))))}
{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}


{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}
{ Procedure-Name..: MN_SpeichernClick                                          }
{ Erstellt durch..: Cargo_03                                                   }
{ Geändert durch..: Cargo_03                                                   }
{ Stand...........: 12.05.2010                                                 }
{ Letzte Änderung.: 12.05.2010                                                 }
{ Beschreibung....: Wenn der Menüpunkt "Passwort in INI-Datei speichern" ange- }
{                   klickt wurde, sollen alle Werte in einer Ini-Datei mit     }
{                   Namen "Krypt.ini" gespeichert werden.                      }
{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}
Procedure TMF.MN_SpeichernClick(Sender: TObject);
Var KRIni : TIniFile;
Begin
  {++++++++++++++++++++  Ini-Datei speichern.  ++++++++++++++++++++++++++++++++}
  KRIni := TIniFile.Create(VzHome+'Krypt.ini',True);
  {--------------------  Verbindung 1 speichern.  -----------------------------}
  KRIni.WriteString ('Passwort','Schluessel'     ,PWD_Key.Text      );
  KRIni.WriteString ('Passwort','Original'       ,PWD_Quelle.Text   );
  KRIni.WriteString ('Passwort','Verschluesselt' ,PWD_Krypt.Text    );
  KRIni.WriteString ('Passwort','VerschlDreh'    ,PWD_KryptDreh.Text);
  KRIni.WriteString ('Passwort','Entschluesselt' ,PWD_Entkrypt.Text );
  KRIni.Free;
EnD;
{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}
{((((((((((((((((((((((     Ende der Procedure     ))))))))))))))))))))))))))))}
{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}



{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}
{ Procedure-Name..: BTN_KryptClick                                             }
{ Erstellt durch..: Cargo_03                                                   }
{ Geändert durch..: Cargo_03                                                   }
{ Stand...........: 12.05.2010                                                 }
{ Letzte Änderung.: 12.05.2010                                                 }
{ Beschreibung....: Wenn der Button "Krypt" geklickt wird, soll das Passwort   }
{                   verchlüsselt und im Edit-Feld "Passwort verschlüsselt" an- }
{                   gezeigt werden.                                            }
{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}
Procedure TMF.BTN_KryptClick(Sender: TObject);
Begin
  PWD_Krypt.Text     := XOrEncode(PWD_Key.Text,PWD_Quelle.Text);
  PWD_KryptDreh.Text := Dreh(PWD_Krypt.Text);
EnD;
{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}
{((((((((((((((((((((((     Ende der Procedure     ))))))))))))))))))))))))))))}
{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}


{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}
{ Procedure-Name..: BTN_EntkryptClick                                          }
{ Erstellt durch..: Cargo_03                                                   }
{ Geändert durch..: Cargo_03                                                   }
{ Stand...........: 12.05.2010                                                 }
{ Letzte Änderung.: 12.05.2010                                                 }
{ Beschreibung....: Wenn der Button "Entkrypt" geklickt wird, soll das ver-    }
{                   schlüsselte Passwort wieder entschlüsselt und im Edit-Feld }
{                   "Passwort entschlüsselt" angezeigt werden.                 }
{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}
Procedure TMF.BTN_EntkryptClick(Sender: TObject);
Begin
  PWD_Entkrypt.Text := XOrDecode(PWD_Key.Text,Dreh(PWD_KryptDreh.Text));
EnD;
{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}
{((((((((((((((((((((((     Ende der Procedure     ))))))))))))))))))))))))))))}
{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}


{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}
{ Procedure-Name..: BTN_ClearClick                                             }
{ Erstellt durch..: Cargo_03                                                   }
{ Geändert durch..: Cargo_03                                                   }
{ Stand...........: 12.05.2010                                                 }
{ Letzte Änderung.: 12.05.2010                                                 }
{ Beschreibung....: Wenn der Button "Clear" geklickt wird, sollen alle Edit-   }
{                   felder geleert werden.                                     }
{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}
Procedure TMF.BTN_ClearClick(Sender: TObject);
Begin
  PWD_Quelle.Text    := '';
  PWD_Key.Text       := '';
  PWD_Krypt.Text     := '';
  PWD_Entkrypt.Text  := '';
  PWD_KryptDreh.Text := '';
EnD;
{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}
{((((((((((((((((((((((     Ende der Procedure     ))))))))))))))))))))))))))))}
{""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""}



initialization
  {$I main.lrs}

end.

